(* This file is generated by Why3's Coq 8.4 driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require Import ZOdiv.
Require Import Rbasic_fun.
Require BuiltIn.
Require int.Int.
Require int.Abs.
Require int.ComputerDivision.
Require bool.Bool.
Require real.Real.
Require real.RealInfix.
Require real.Abs.
Require real.FromInt.
Require floating_point.Rounding.
Require floating_point.SingleFormat.
Require floating_point.DoubleFormat.
Require floating_point.Single.
Require floating_point.Double.
Require Jessie_memory_model.

(* Why3 assumption *)
Definition unit := unit.

Axiom charP : Type.
Parameter charP_WhyType : WhyType charP.
Existing Instance charP_WhyType.

Axiom doubleP : Type.
Parameter doubleP_WhyType : WhyType doubleP.
Existing Instance doubleP_WhyType.

Axiom int32 : Type.
Parameter int32_WhyType : WhyType int32.
Existing Instance int32_WhyType.

Axiom int8 : Type.
Parameter int8_WhyType : WhyType int8.
Existing Instance int8_WhyType.

Axiom padding : Type.
Parameter padding_WhyType : WhyType padding.
Existing Instance padding_WhyType.

Axiom uint8 : Type.
Parameter uint8_WhyType : WhyType uint8.
Existing Instance uint8_WhyType.

Axiom unsigned_charP : Type.
Parameter unsigned_charP_WhyType : WhyType unsigned_charP.
Existing Instance unsigned_charP_WhyType.

Axiom voidP : Type.
Parameter voidP_WhyType : WhyType voidP.
Existing Instance voidP_WhyType.

(* Why3 assumption *)
Definition bounded (z_0:R) (bound:R): Prop := ((Rabs z_0) <= bound)%R.

Parameter charP_tag: (Jessie_memory_model.tag_id charP).

Axiom charP_int : ((Jessie_memory_model.int_of_tag charP_tag) = 1%Z).

Parameter charP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer charP).

Axiom charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  charP)),
  (p = (charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom charP_parenttag_bottom : (Jessie_memory_model.parenttag charP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id charP))).

Axiom charP_tags : forall (x:(Jessie_memory_model.pointer charP)),
  forall (charP_tag_table:(Jessie_memory_model.tag_table charP)),
  (Jessie_memory_model.instanceof charP_tag_table x charP_tag).

Parameter doubleP_tag: (Jessie_memory_model.tag_id doubleP).

Axiom doubleP_int : ((Jessie_memory_model.int_of_tag doubleP_tag) = 1%Z).

Parameter doubleP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer doubleP).

Axiom doubleP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  doubleP)),
  (p = (doubleP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom doubleP_parenttag_bottom : (Jessie_memory_model.parenttag doubleP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id doubleP))).

Axiom doubleP_tags : forall (x:(Jessie_memory_model.pointer doubleP)),
  forall (doubleP_tag_table:(Jessie_memory_model.tag_table doubleP)),
  (Jessie_memory_model.instanceof doubleP_tag_table x doubleP_tag).

Parameter integer_of_int32: int32 -> Z.

(* Why3 assumption *)
Definition eq_int32 (x:int32) (y:int32): Prop :=
  ((integer_of_int32 x) = (integer_of_int32 y)).

Parameter integer_of_int8: int8 -> Z.

(* Why3 assumption *)
Definition eq_int8 (x:int8) (y:int8): Prop :=
  ((integer_of_int8 x) = (integer_of_int8 y)).

Parameter integer_of_uint8: uint8 -> Z.

(* Why3 assumption *)
Definition eq_uint8 (x:uint8) (y:uint8): Prop :=
  ((integer_of_uint8 x) = (integer_of_uint8 y)).

Parameter int32_of_integer: Z -> int32.

Axiom int32_coerce : forall (x:Z), (((-2147483648%Z)%Z <= x)%Z /\
  (x <= 2147483647%Z)%Z) -> ((integer_of_int32 (int32_of_integer x)) = x).

Axiom int32_extensionality : forall (x:int32), forall (y:int32),
  ((integer_of_int32 x) = (integer_of_int32 y)) -> (x = y).

Axiom int32_range : forall (x:int32),
  ((-2147483648%Z)%Z <= (integer_of_int32 x))%Z /\
  ((integer_of_int32 x) <= 2147483647%Z)%Z.

Parameter int8_of_integer: Z -> int8.

Axiom int8_coerce : forall (x:Z), (((-128%Z)%Z <= x)%Z /\ (x <= 127%Z)%Z) ->
  ((integer_of_int8 (int8_of_integer x)) = x).

Axiom int8_extensionality : forall (x:int8), forall (y:int8),
  ((integer_of_int8 x) = (integer_of_int8 y)) -> (x = y).

Axiom int8_range : forall (x:int8), ((-128%Z)%Z <= (integer_of_int8 x))%Z /\
  ((integer_of_int8 x) <= 127%Z)%Z.

(* Why3 assumption *)
Definition left_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z.

Axiom pointer_addr_of_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (charP_of_pointer_address p))).

Axiom pointer_addr_of_doubleP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (doubleP_of_pointer_address p))).

Parameter unsigned_charP_of_pointer_address: (Jessie_memory_model.pointer
  unit) -> (Jessie_memory_model.pointer unsigned_charP).

Axiom pointer_addr_of_unsigned_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (unsigned_charP_of_pointer_address p))).

Parameter voidP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer voidP).

Axiom pointer_addr_of_voidP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (voidP_of_pointer_address p))).

(* Why3 assumption *)
Definition right_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop :=
  (b <= (Jessie_memory_model.offset_max doubleP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition strict_valid_root_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

Parameter uint8_of_integer: Z -> uint8.

Axiom uint8_coerce : forall (x:Z), ((0%Z <= x)%Z /\ (x <= 255%Z)%Z) ->
  ((integer_of_uint8 (uint8_of_integer x)) = x).

Axiom uint8_extensionality : forall (x:uint8), forall (y:uint8),
  ((integer_of_uint8 x) = (integer_of_uint8 y)) -> (x = y).

Axiom uint8_range : forall (x:uint8), (0%Z <= (integer_of_uint8 x))%Z /\
  ((integer_of_uint8 x) <= 255%Z)%Z.

Parameter unsigned_charP_tag: (Jessie_memory_model.tag_id unsigned_charP).

Axiom unsigned_charP_int : ((Jessie_memory_model.int_of_tag unsigned_charP_tag) = 1%Z).

Axiom unsigned_charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  unsigned_charP)),
  (p = (unsigned_charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom unsigned_charP_parenttag_bottom : (Jessie_memory_model.parenttag
  unsigned_charP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id
  unsigned_charP))).

Axiom unsigned_charP_tags : forall (x:(Jessie_memory_model.pointer
  unsigned_charP)),
  forall (unsigned_charP_tag_table:(Jessie_memory_model.tag_table
  unsigned_charP)), (Jessie_memory_model.instanceof unsigned_charP_tag_table
  x unsigned_charP_tag).

(* Why3 assumption *)
Definition valid_root_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_doubleP (p:(Jessie_memory_model.pointer doubleP)) (a:Z)
  (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max doubleP_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_root_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_doubleP (p:(Jessie_memory_model.pointer doubleP))
  (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max doubleP_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

Parameter voidP_tag: (Jessie_memory_model.tag_id voidP).

Axiom voidP_int : ((Jessie_memory_model.int_of_tag voidP_tag) = 1%Z).

Axiom voidP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  voidP)),
  (p = (voidP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom voidP_parenttag_bottom : (Jessie_memory_model.parenttag voidP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id voidP))).

Axiom voidP_tags : forall (x:(Jessie_memory_model.pointer voidP)),
  forall (voidP_tag_table:(Jessie_memory_model.tag_table voidP)),
  (Jessie_memory_model.instanceof voidP_tag_table x voidP_tag).

Axiom distr_mul_div : forall (x_1:R), forall (y:R), forall (z:R),
  (~ (z = 0%R)) -> ((Rdiv (x_1 * y)%R z)%R = (x_1 * (Rdiv y z)%R)%R).

Axiom round_add_zero : forall (x_0_0:floating_point.DoubleFormat.double),
  ((floating_point.Double.round floating_point.Rounding.NearestTiesToEven
  ((floating_point.Double.value x_0_0) + 0%R)%R) = (floating_point.Double.value x_0_0)).

Axiom round_mul_zero : forall (x_1_0:R),
  ((floating_point.Double.round floating_point.Rounding.NearestTiesToEven
  (x_1_0 * 0%R)%R) = 0%R).

(* Why3 assumption *)
Inductive ref (a:Type) {a_WT:WhyType a} :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a] [a_WT]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

(* Why3 assumption *)
Definition single_of_double_post (m:floating_point.Rounding.mode)
  (x:floating_point.DoubleFormat.double)
  (res:floating_point.SingleFormat.single): Prop :=
  ((floating_point.Single.value res) = (floating_point.Single.round m
  (floating_point.Double.value x))) /\
  (((floating_point.Single.exact res) = (floating_point.Double.exact x)) /\
  ((floating_point.Single.model res) = (floating_point.Double.model x))).

(* Why3 assumption *)
Definition double_of_single_post (x:floating_point.SingleFormat.single)
  (res:floating_point.DoubleFormat.double): Prop :=
  ((floating_point.Double.value res) = (floating_point.Single.value x)) /\
  (((floating_point.Double.exact res) = (floating_point.Single.exact x)) /\
  ((floating_point.Double.model res) = (floating_point.Single.model x))).

Parameter eq_unit: unit -> unit -> Prop.

Parameter neq_unit: unit -> unit -> Prop.

Parameter eq_bool: bool -> bool -> Prop.

Parameter neq_bool: bool -> bool -> Prop.

Parameter lt_int: Z -> Z -> Prop.

Parameter le_int: Z -> Z -> Prop.

Parameter gt_int: Z -> Z -> Prop.

Parameter ge_int: Z -> Z -> Prop.

Parameter eq_int: Z -> Z -> Prop.

Parameter neq_int: Z -> Z -> Prop.

Parameter add_int: Z -> Z -> Z.

Parameter sub_int: Z -> Z -> Z.

Parameter mul_int: Z -> Z -> Z.

Parameter neg_int: Z -> Z.

(* Why3 assumption *)
Definition zwf_zero (a:Z) (b:Z): Prop := (0%Z <= b)%Z /\ (a < b)%Z.

Parameter lt_int_bool: Z -> Z -> bool.

Parameter le_int_bool: Z -> Z -> bool.

Parameter gt_int_bool: Z -> Z -> bool.

Parameter ge_int_bool: Z -> Z -> bool.

Parameter eq_int_bool: Z -> Z -> bool.

Parameter neq_int_bool: Z -> Z -> bool.

Axiom Lt_int_bool_axiom : forall (x:Z), forall (y:Z), ((lt_int_bool x
  y) = true) <-> (x < y)%Z.

Axiom Le_int_bool_axiom : forall (x:Z), forall (y:Z), ((le_int_bool x
  y) = true) <-> (x <= y)%Z.

Axiom Gt_int_bool_axiom : forall (x:Z), forall (y:Z), ((gt_int_bool x
  y) = true) <-> (y < x)%Z.

Axiom Ge_int_bool_axiom : forall (x:Z), forall (y:Z), ((ge_int_bool x
  y) = true) <-> (y <= x)%Z.

Axiom Eq_int_bool_axiom : forall (x:Z), forall (y:Z), ((eq_int_bool x
  y) = true) <-> (x = y).

Axiom Neq_int_bool_axiom : forall (x:Z), forall (y:Z), ((neq_int_bool x
  y) = true) <-> ~ (x = y).

Parameter abs_int: Z -> Z.

Axiom Abs_int_pos : forall (x:Z), (0%Z <= x)%Z -> ((Zabs x) = x).

Axiom Abs_int_neg : forall (x:Z), (x <= 0%Z)%Z -> ((Zabs x) = (-x)%Z).

Parameter int_max: Z -> Z -> Z.

Parameter int_min: Z -> Z -> Z.

Axiom Int_max_is_ge : forall (x:Z), forall (y:Z), (x <= (int_max x y))%Z /\
  (y <= (int_max x y))%Z.

Axiom Int_max_is_some : forall (x:Z), forall (y:Z), ((int_max x y) = x) \/
  ((int_max x y) = y).

Axiom Int_min_is_le : forall (x:Z), forall (y:Z), ((int_min x y) <= x)%Z /\
  ((int_min x y) <= y)%Z.

Axiom Int_min_is_some : forall (x:Z), forall (y:Z), ((int_min x y) = x) \/
  ((int_min x y) = y).



(* Why3 goal *)
Theorem WP_parameter__InterPolate_ensures_big : forall (x_0:floating_point.DoubleFormat.double)
  (usX:(Jessie_memory_model.pointer doubleP))
  (usY:(Jessie_memory_model.pointer doubleP))
  (usV:(Jessie_memory_model.pointer doubleP)) (n_1:int32)
  (doubleP_X_1_alloc_table:(Jessie_memory_model.alloc_table doubleP))
  (doubleP_Y_2_alloc_table:(Jessie_memory_model.alloc_table doubleP))
  (doubleP_V_3_alloc_table:(Jessie_memory_model.alloc_table doubleP))
  (doubleP_doubleM_X_1:(Jessie_memory_model.memory doubleP
  floating_point.DoubleFormat.double))
  (doubleP_doubleM_Y_2:(Jessie_memory_model.memory doubleP
  floating_point.DoubleFormat.double))
  (doubleP_doubleM_V_3:(Jessie_memory_model.memory doubleP
  floating_point.DoubleFormat.double)),
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX
  (integer_of_int32 n_1)))) <= (floating_point.Double.value x_0))%R /\
  ((3%Z <= (integer_of_int32 n_1))%Z /\
  (((integer_of_int32 n_1) <= 17%Z)%Z /\
  (((Jessie_memory_model.offset_min doubleP_X_1_alloc_table usX) <= 0%Z)%Z /\
  (((integer_of_int32 n_1) <= (Jessie_memory_model.offset_max doubleP_X_1_alloc_table
  usX))%Z /\ (((Jessie_memory_model.offset_min doubleP_Y_2_alloc_table
  usY) <= 0%Z)%Z /\
  (((integer_of_int32 n_1) <= (Jessie_memory_model.offset_max doubleP_Y_2_alloc_table
  usY))%Z /\ (((Jessie_memory_model.offset_min doubleP_V_3_alloc_table
  usV) <= 0%Z)%Z /\
  (((integer_of_int32 n_1) <= (Jessie_memory_model.offset_max doubleP_V_3_alloc_table
  usV))%Z /\ ((bounded (floating_point.Double.value x_0) (1 * 8)%R) /\
  ((forall (k:Z), ((0%Z <= k)%Z /\ (k <= (integer_of_int32 n_1))%Z) ->
  (bounded
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX k))) (1 * 8)%R)) /\ ((forall (k_0:Z),
  ((0%Z <= k_0)%Z /\ (k_0 <= (integer_of_int32 n_1))%Z) -> (bounded
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY k_0))) (1 * 8)%R)) /\ ((forall (k_1:Z),
  ((0%Z <= k_1)%Z /\ (k_1 <= (integer_of_int32 n_1))%Z) -> (bounded
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV k_1))) (1 * 8)%R)) /\
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX
  0%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX 1%Z)))) /\ ((forall (k1:Z), forall (k2:Z),
  ((1%Z <= k1)%Z /\ ((k1 < k2)%Z /\ (k2 <= (integer_of_int32 n_1))%Z)) ->
  ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX
  k1))) < (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX k2))))%R) /\
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY
  0%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY 1%Z)))) /\
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV
  0%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV (integer_of_int32 n_1))))) /\
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV (integer_of_int32 n_1)))) = 0%R) /\
  forall (k_2:Z), ((1%Z <= k_2)%Z /\
  (k_2 <= ((integer_of_int32 n_1) - 1%Z)%Z)%Z) ->
  ((Rabs ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV
  k_2))) - (Rdiv ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY
  (k_2 + 1%Z)%Z))) - (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY
  k_2))))%R ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX
  (k_2 + 1%Z)%Z))) - (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX
  k_2))))%R)%R)%R) <= (1 / 1125899906842624)%R)%R)))))))))))))))))) ->
  forall (o:int32), ((integer_of_int32 o) = 0%Z) -> forall (i:int32),
  (i = o) -> forall (o1:int32),
  ((integer_of_int32 o1) = ((integer_of_int32 n_1) + 1%Z)%Z) ->
  forall (o2:int32),
  ((integer_of_int32 o2) = (ZOdiv (integer_of_int32 o1) 2%Z)) ->
  forall (m:int32), (m = o2) -> (((2%Z <= (integer_of_int32 m))%Z /\
  ((integer_of_int32 m) <= 9%Z)%Z) ->
  (((integer_of_int32 m) <= (integer_of_int32 n_1))%Z -> let o3 :=
  (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX (integer_of_int32 m))) in
  forall (result:bool), (((result = true) /\
  ((floating_point.Double.value o3) <= (floating_point.Double.value x_0))%R) \/
  ((~ (result = true)) /\
  ((floating_point.Double.value x_0) < (floating_point.Double.value o3))%R)) ->
  ((result = true) -> forall (i1:int32), (i1 = m) -> forall (i0:int32),
  (i0 = i1) -> forall (i2:int32),
  (((integer_of_int32 i0) <= (integer_of_int32 i2))%Z /\
  ((integer_of_int32 i2) <= (integer_of_int32 n_1))%Z) ->
  ((~ ((integer_of_int32 i2) < (integer_of_int32 n_1))%Z) ->
  forall (i_f:int32), (i_f = i2) ->
  ((((integer_of_int32 i2) < (integer_of_int32 n_1))%Z ->
  ((floating_point.Double.value x_0) < (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX ((integer_of_int32 i2) + 1%Z)%Z))))%R) ->
  (((integer_of_int32 i2) = (integer_of_int32 n_1)) -> ((bounded
  (floating_point.Double.value x_0) (1 * 8)%R) -> ((bounded
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX (integer_of_int32 i2)))) (1 * 8)%R) ->
  ((bounded
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY (integer_of_int32 i2)))) (1 * 8)%R) ->
  ((bounded
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV (integer_of_int32 i2)))) (1 * 8)%R) ->
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV (integer_of_int32 i2)))) = 0%R) ->
  forall (o4:floating_point.DoubleFormat.double),
  (floating_point.Double.sub_post floating_point.Rounding.NearestTiesToEven
  x_0 (Jessie_memory_model.select doubleP_doubleM_X_1
  (Jessie_memory_model.shift usX (integer_of_int32 i2))) o4) ->
  forall (o5:floating_point.DoubleFormat.double),
  (floating_point.Double.mul_post floating_point.Rounding.NearestTiesToEven
  o4 (Jessie_memory_model.select doubleP_doubleM_V_3
  (Jessie_memory_model.shift usV (integer_of_int32 i2))) o5) ->
  forall (r:floating_point.DoubleFormat.double), (r = o5) ->
  (((floating_point.Double.value r) = 0%R) ->
  forall (o6:floating_point.DoubleFormat.double),
  (floating_point.Double.add_post floating_point.Rounding.NearestTiesToEven
  (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY (integer_of_int32 i2))) r o6) ->
  forall (r1:floating_point.DoubleFormat.double), (r1 = o6) ->
  ((floating_point.Double.value r1) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_Y_2
  (Jessie_memory_model.shift usY (integer_of_int32 i2))))))))))))))))).
(* intros x_0 usX usY usV n_1 doubleP_X_1_alloc_table doubleP_Y_2_alloc_table
   doubleP_V_3_alloc_table doubleP_doubleM_X_1 doubleP_doubleM_Y_2
   doubleP_doubleM_V_3
   (h1,(h2,(h3,(h4,(h5,(h6,(h7,(h8,(h9,(h10,(h11,(h12,(h13,(h14,(h15,(h16,(h17,(h18,h19))))))))))))))))))
   o h20 i h21 o1 h22 o2 h23 m h24 (h25,h26) h27 o3 result h28 h29 i1 h30 i0
   h31 i2 (h32,h33) h34 i_f h35 h36 h37 h38 h39 h40 h41 h42 o4 h43 o5 h44 r
   h45 h46 o6 h47 r1 h48. *)
(* YOU MAY EDIT THE PROOF BELOW *)
intros.
subst r1.
destruct H25 as (h1&h2&h3).
rewrite h1.
rewrite H24.
now rewrite round_add_zero.
Qed.


