(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require Reals.R_sqrt.
Require BuiltIn.
Require int.Int.
Require bool.Bool.
Require real.Real.
Require real.RealInfix.
Require real.Square.
Require Jessie_memory_model.

Axiom charP : Type.
Parameter charP_WhyType : WhyType charP.
Existing Instance charP_WhyType.

Axiom doubleP : Type.
Parameter doubleP_WhyType : WhyType doubleP.
Existing Instance doubleP_WhyType.

Axiom int32 : Type.
Parameter int32_WhyType : WhyType int32.
Existing Instance int32_WhyType.

Axiom int8 : Type.
Parameter int8_WhyType : WhyType int8.
Existing Instance int8_WhyType.

Axiom padding : Type.
Parameter padding_WhyType : WhyType padding.
Existing Instance padding_WhyType.

Axiom voidP : Type.
Parameter voidP_WhyType : WhyType voidP.
Existing Instance voidP_WhyType.

Parameter charP_tag: (Jessie_memory_model.tag_id charP).

Axiom charP_int : ((Jessie_memory_model.int_of_tag charP_tag) = 1%Z).

Parameter charP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer charP).

Axiom charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  charP)),
  (p = (charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom charP_parenttag_bottom : (Jessie_memory_model.parenttag charP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id charP))).

Axiom charP_tags : forall (x:(Jessie_memory_model.pointer charP)),
  forall (charP_tag_table:(Jessie_memory_model.tag_table charP)),
  (Jessie_memory_model.instanceof charP_tag_table x charP_tag).

Parameter doubleP_tag: (Jessie_memory_model.tag_id doubleP).

Axiom doubleP_int : ((Jessie_memory_model.int_of_tag doubleP_tag) = 1%Z).

Parameter doubleP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer doubleP).

Axiom doubleP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  doubleP)),
  (p = (doubleP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom doubleP_parenttag_bottom : (Jessie_memory_model.parenttag doubleP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id doubleP))).

Axiom doubleP_tags : forall (x:(Jessie_memory_model.pointer doubleP)),
  forall (doubleP_tag_table:(Jessie_memory_model.tag_table doubleP)),
  (Jessie_memory_model.instanceof doubleP_tag_table x doubleP_tag).

Parameter integer_of_int32: int32 -> Z.

(* Why3 assumption *)
Definition eq_int32 (x:int32) (y:int32): Prop :=
  ((integer_of_int32 x) = (integer_of_int32 y)).

Parameter integer_of_int8: int8 -> Z.

(* Why3 assumption *)
Definition eq_int8 (x:int8) (y:int8): Prop :=
  ((integer_of_int8 x) = (integer_of_int8 y)).

Parameter int32_of_integer: Z -> int32.

Axiom int32_coerce : forall (x:Z), (((-2147483648%Z)%Z <= x)%Z /\
  (x <= 2147483647%Z)%Z) -> ((integer_of_int32 (int32_of_integer x)) = x).

Axiom int32_extensionality : forall (x:int32), forall (y:int32),
  ((integer_of_int32 x) = (integer_of_int32 y)) -> (x = y).

Axiom int32_range : forall (x:int32),
  ((-2147483648%Z)%Z <= (integer_of_int32 x))%Z /\
  ((integer_of_int32 x) <= 2147483647%Z)%Z.

Parameter int8_of_integer: Z -> int8.

Axiom int8_coerce : forall (x:Z), (((-128%Z)%Z <= x)%Z /\ (x <= 127%Z)%Z) ->
  ((integer_of_int8 (int8_of_integer x)) = x).

Axiom int8_extensionality : forall (x:int8), forall (y:int8),
  ((integer_of_int8 x) = (integer_of_int8 y)) -> (x = y).

Axiom int8_range : forall (x:int8), ((-128%Z)%Z <= (integer_of_int8 x))%Z /\
  ((integer_of_int8 x) <= 127%Z)%Z.

(* Why3 assumption *)
Definition product1 (q1_0:(Jessie_memory_model.pointer doubleP))
  (q2_0:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q2_0_6_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_0_5_at_L:(Jessie_memory_model.memory doubleP R)): R :=
  (((((Jessie_memory_model.select doubleP_doubleM_q1_0_5_at_L
  (Jessie_memory_model.shift q1_0
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_0_6_at_L
  (Jessie_memory_model.shift q2_0
  0%Z)))%R - ((Jessie_memory_model.select doubleP_doubleM_q1_0_5_at_L
  (Jessie_memory_model.shift q1_0
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_0_6_at_L
  (Jessie_memory_model.shift q2_0
  1%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_0_5_at_L
  (Jessie_memory_model.shift q1_0
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_0_6_at_L
  (Jessie_memory_model.shift q2_0
  2%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_0_5_at_L
  (Jessie_memory_model.shift q1_0
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_0_6_at_L
  (Jessie_memory_model.shift q2_0 3%Z)))%R)%R.

(* Why3 assumption *)
Definition product2 (q1_1:(Jessie_memory_model.pointer doubleP))
  (q2_1:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q2_1_8_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_1_7_at_L:(Jessie_memory_model.memory doubleP R)): R :=
  (((((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  1%Z)))%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  0%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  3%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1 2%Z)))%R)%R.

(* Why3 assumption *)
Definition product3 (q1_2:(Jessie_memory_model.pointer doubleP))
  (q2_2:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q2_2_10_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_2_9_at_L:(Jessie_memory_model.memory doubleP R)): R :=
  (((((Jessie_memory_model.select doubleP_doubleM_q1_2_9_at_L
  (Jessie_memory_model.shift q1_2
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_2_10_at_L
  (Jessie_memory_model.shift q2_2
  2%Z)))%R - ((Jessie_memory_model.select doubleP_doubleM_q1_2_9_at_L
  (Jessie_memory_model.shift q1_2
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_2_10_at_L
  (Jessie_memory_model.shift q2_2
  3%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_2_9_at_L
  (Jessie_memory_model.shift q1_2
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_2_10_at_L
  (Jessie_memory_model.shift q2_2
  0%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_2_9_at_L
  (Jessie_memory_model.shift q1_2
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_2_10_at_L
  (Jessie_memory_model.shift q2_2 1%Z)))%R)%R.

(* Why3 assumption *)
Definition product4 (q1_3:(Jessie_memory_model.pointer doubleP))
  (q2_3:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q2_3_12_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_3_11_at_L:(Jessie_memory_model.memory doubleP R)): R :=
  (((((Jessie_memory_model.select doubleP_doubleM_q1_3_11_at_L
  (Jessie_memory_model.shift q1_3
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_3_12_at_L
  (Jessie_memory_model.shift q2_3
  3%Z)))%R + ((Jessie_memory_model.select doubleP_doubleM_q1_3_11_at_L
  (Jessie_memory_model.shift q1_3
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_3_12_at_L
  (Jessie_memory_model.shift q2_3
  2%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_3_11_at_L
  (Jessie_memory_model.shift q1_3
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_3_12_at_L
  (Jessie_memory_model.shift q2_3
  1%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_3_11_at_L
  (Jessie_memory_model.shift q1_3
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_3_12_at_L
  (Jessie_memory_model.shift q2_3 0%Z)))%R)%R.

(* Why3 assumption *)
Definition is_product (q1_4:(Jessie_memory_model.pointer doubleP))
  (q2_4:(Jessie_memory_model.pointer doubleP))
  (q:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q_15_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q2_4_14_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_4_13_at_L:(Jessie_memory_model.memory doubleP
  R)): Prop := ((Jessie_memory_model.select doubleP_doubleM_q_15_at_L
  (Jessie_memory_model.shift q 0%Z)) = (product1 q1_4 q2_4
  doubleP_doubleM_q2_4_14_at_L doubleP_doubleM_q1_4_13_at_L)) /\
  (((Jessie_memory_model.select doubleP_doubleM_q_15_at_L
  (Jessie_memory_model.shift q 1%Z)) = (product2 q1_4 q2_4
  doubleP_doubleM_q2_4_14_at_L doubleP_doubleM_q1_4_13_at_L)) /\
  (((Jessie_memory_model.select doubleP_doubleM_q_15_at_L
  (Jessie_memory_model.shift q 2%Z)) = (product3 q1_4 q2_4
  doubleP_doubleM_q2_4_14_at_L doubleP_doubleM_q1_4_13_at_L)) /\
  ((Jessie_memory_model.select doubleP_doubleM_q_15_at_L
  (Jessie_memory_model.shift q 3%Z)) = (product4 q1_4 q2_4
  doubleP_doubleM_q2_4_14_at_L doubleP_doubleM_q1_4_13_at_L)))).

(* Why3 assumption *)
Definition left_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z.

Axiom pointer_addr_of_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (charP_of_pointer_address p))).

Axiom pointer_addr_of_doubleP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (doubleP_of_pointer_address p))).

Parameter voidP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer voidP).

Axiom pointer_addr_of_voidP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (voidP_of_pointer_address p))).

(* Why3 assumption *)
Definition quat_eq (q1:(Jessie_memory_model.pointer doubleP))
  (q2:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q2_2_at_L2:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_1_at_L1:(Jessie_memory_model.memory doubleP
  R)): Prop := ((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  0%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 0%Z))) /\
  (((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  1%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 1%Z))) /\
  (((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  2%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 2%Z))) /\
  ((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  3%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 3%Z))))).

(* Why3 assumption *)
Definition quat_norm (q_0_0:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q_0_19_at_L:(Jessie_memory_model.memory doubleP R)): R :=
  (Reals.R_sqrt.sqrt (((((Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  0%Z)))%R + ((Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  1%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  2%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_0_19_at_L
  (Jessie_memory_model.shift q_0_0 3%Z)))%R)%R).

(* Why3 assumption *)
Definition right_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop :=
  (b <= (Jessie_memory_model.offset_max doubleP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition strict_valid_root_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

(* Why3 assumption *)
Definition valid_root_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_doubleP (p:(Jessie_memory_model.pointer doubleP)) (a:Z)
  (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max doubleP_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_root_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_doubleP (p:(Jessie_memory_model.pointer doubleP))
  (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max doubleP_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_struct_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

Parameter voidP_tag: (Jessie_memory_model.tag_id voidP).

Axiom voidP_int : ((Jessie_memory_model.int_of_tag voidP_tag) = 1%Z).

Axiom voidP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  voidP)),
  (p = (voidP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom voidP_parenttag_bottom : (Jessie_memory_model.parenttag voidP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id voidP))).

Axiom voidP_tags : forall (x:(Jessie_memory_model.pointer voidP)),
  forall (voidP_tag_table:(Jessie_memory_model.tag_table voidP)),
  (Jessie_memory_model.instanceof voidP_tag_table x voidP_tag).

Require Import Why3.
Ltac ae := why3 "Alt-Ergo,2.0.0," timelimit 5; admit.

(* Why3 goal *)
Theorem norm_product : forall (doubleP_doubleM_q_1_23_at_L:(Jessie_memory_model.memory
  doubleP R)),
  forall (doubleP_doubleM_q2_5_22_at_L:(Jessie_memory_model.memory doubleP
  R)), forall (doubleP_doubleM_q1_5_21_at_L:(Jessie_memory_model.memory
  doubleP R)), forall (q1_5_0:(Jessie_memory_model.pointer doubleP)),
  forall (q2_5_0:(Jessie_memory_model.pointer doubleP)),
  forall (q_1:(Jessie_memory_model.pointer doubleP)), (is_product q1_5_0
  q2_5_0 q_1 doubleP_doubleM_q_1_23_at_L doubleP_doubleM_q2_5_22_at_L
  doubleP_doubleM_q1_5_21_at_L) -> ((quat_norm q_1
  doubleP_doubleM_q_1_23_at_L) = ((quat_norm q1_5_0
  doubleP_doubleM_q1_5_21_at_L) * (quat_norm q2_5_0
  doubleP_doubleM_q2_5_22_at_L))%R).
(* Why3 intros doubleP_doubleM_q_1_23_at_L doubleP_doubleM_q2_5_22_at_L
        doubleP_doubleM_q1_5_21_at_L q1_5_0 q2_5_0 q_1 h1. *)
(* intros doubleP_doubleM_q_1_15_at_L doubleP_doubleM_q2_1_14_at_L
   doubleP_doubleM_q1_1_13_at_L q1_1_0 q2_1_0 q_1_0 h1. *)
intros doubleP_doubleM_q_1_15_at_L doubleP_doubleM_q2_1_14_at_L
doubleP_doubleM_q1_1_13_at_L q1_1_0 q2_1_0 q_1_0 h1.
unfold quat_norm.
rewrite <- R_sqrt.sqrt_mult.
apply f_equal.
unfold is_product,product1,product2,product3,product4 in h1.
ring_simplify.
destruct h1 as (h1 & h2 & h3 & h4).
rewrite h1.
rewrite h2.
rewrite h3.
rewrite h4.
ring.
ae.
ae.
Admitted.

