(* This file is generated by Why3's Coq 8.4 driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require Import ZOdiv.
Require Import R_sqrt.
Require BuiltIn.
Require int.Int.
Require int.Abs.
Require int.ComputerDivision.
Require bool.Bool.
Require real.Real.
Require real.RealInfix.
Require real.FromInt.
Require real.Square.
Require Jessie_memory_model.

(* Why3 assumption *)
Definition unit := unit.

Axiom charP : Type.
Parameter charP_WhyType : WhyType charP.
Existing Instance charP_WhyType.

Axiom doubleP : Type.
Parameter doubleP_WhyType : WhyType doubleP.
Existing Instance doubleP_WhyType.

Axiom int32 : Type.
Parameter int32_WhyType : WhyType int32.
Existing Instance int32_WhyType.

Axiom int8 : Type.
Parameter int8_WhyType : WhyType int8.
Existing Instance int8_WhyType.

Axiom padding : Type.
Parameter padding_WhyType : WhyType padding.
Existing Instance padding_WhyType.

Axiom uint8 : Type.
Parameter uint8_WhyType : WhyType uint8.
Existing Instance uint8_WhyType.

Axiom unsigned_charP : Type.
Parameter unsigned_charP_WhyType : WhyType unsigned_charP.
Existing Instance unsigned_charP_WhyType.

Axiom voidP : Type.
Parameter voidP_WhyType : WhyType voidP.
Existing Instance voidP_WhyType.

Parameter charP_tag: (Jessie_memory_model.tag_id charP).

Axiom charP_int : ((Jessie_memory_model.int_of_tag charP_tag) = 1%Z).

Parameter charP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer charP).

Axiom charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  charP)),
  (p = (charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom charP_parenttag_bottom : (Jessie_memory_model.parenttag charP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id charP))).

Axiom charP_tags : forall (x:(Jessie_memory_model.pointer charP)),
  forall (charP_tag_table:(Jessie_memory_model.tag_table charP)),
  (Jessie_memory_model.instanceof charP_tag_table x charP_tag).

Parameter doubleP_tag: (Jessie_memory_model.tag_id doubleP).

Axiom doubleP_int : ((Jessie_memory_model.int_of_tag doubleP_tag) = 1%Z).

Parameter doubleP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer doubleP).

Axiom doubleP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  doubleP)),
  (p = (doubleP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom doubleP_parenttag_bottom : (Jessie_memory_model.parenttag doubleP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id doubleP))).

Axiom doubleP_tags : forall (x:(Jessie_memory_model.pointer doubleP)),
  forall (doubleP_tag_table:(Jessie_memory_model.tag_table doubleP)),
  (Jessie_memory_model.instanceof doubleP_tag_table x doubleP_tag).

Parameter integer_of_int32: int32 -> Z.

(* Why3 assumption *)
Definition eq_int32 (x:int32) (y:int32): Prop :=
  ((integer_of_int32 x) = (integer_of_int32 y)).

Parameter integer_of_int8: int8 -> Z.

(* Why3 assumption *)
Definition eq_int8 (x:int8) (y:int8): Prop :=
  ((integer_of_int8 x) = (integer_of_int8 y)).

Parameter integer_of_uint8: uint8 -> Z.

(* Why3 assumption *)
Definition eq_uint8 (x:uint8) (y:uint8): Prop :=
  ((integer_of_uint8 x) = (integer_of_uint8 y)).

Parameter int32_of_integer: Z -> int32.

Axiom int32_coerce : forall (x:Z), (((-2147483648%Z)%Z <= x)%Z /\
  (x <= 2147483647%Z)%Z) -> ((integer_of_int32 (int32_of_integer x)) = x).

Axiom int32_extensionality : forall (x:int32), forall (y:int32),
  ((integer_of_int32 x) = (integer_of_int32 y)) -> (x = y).

Axiom int32_range : forall (x:int32),
  ((-2147483648%Z)%Z <= (integer_of_int32 x))%Z /\
  ((integer_of_int32 x) <= 2147483647%Z)%Z.

Parameter int8_of_integer: Z -> int8.

Axiom int8_coerce : forall (x:Z), (((-128%Z)%Z <= x)%Z /\ (x <= 127%Z)%Z) ->
  ((integer_of_int8 (int8_of_integer x)) = x).

Axiom int8_extensionality : forall (x:int8), forall (y:int8),
  ((integer_of_int8 x) = (integer_of_int8 y)) -> (x = y).

Axiom int8_range : forall (x:int8), ((-128%Z)%Z <= (integer_of_int8 x))%Z /\
  ((integer_of_int8 x) <= 127%Z)%Z.

(* Why3 assumption *)
Definition is_div_scalar (q1_3:(Jessie_memory_model.pointer doubleP)) (f:R)
  (q_2:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q_2_14_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_3_13_at_L1:(Jessie_memory_model.memory doubleP
  R)): Prop := (0%R < f)%R /\
  (((Jessie_memory_model.select doubleP_doubleM_q_2_14_at_L
  (Jessie_memory_model.shift q_2
  0%Z)) = (Rdiv (Jessie_memory_model.select doubleP_doubleM_q1_3_13_at_L1
  (Jessie_memory_model.shift q1_3 0%Z)) f)%R) /\
  (((Jessie_memory_model.select doubleP_doubleM_q_2_14_at_L
  (Jessie_memory_model.shift q_2
  1%Z)) = (Rdiv (Jessie_memory_model.select doubleP_doubleM_q1_3_13_at_L1
  (Jessie_memory_model.shift q1_3 1%Z)) f)%R) /\
  (((Jessie_memory_model.select doubleP_doubleM_q_2_14_at_L
  (Jessie_memory_model.shift q_2
  2%Z)) = (Rdiv (Jessie_memory_model.select doubleP_doubleM_q1_3_13_at_L1
  (Jessie_memory_model.shift q1_3 2%Z)) f)%R) /\
  ((Jessie_memory_model.select doubleP_doubleM_q_2_14_at_L
  (Jessie_memory_model.shift q_2
  3%Z)) = (Rdiv (Jessie_memory_model.select doubleP_doubleM_q1_3_13_at_L1
  (Jessie_memory_model.shift q1_3 3%Z)) f)%R)))).

(* Why3 assumption *)
Definition is_product (q1_1:(Jessie_memory_model.pointer doubleP))
  (q2_1:(Jessie_memory_model.pointer doubleP))
  (q_0_0:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q_0_9_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q2_1_8_at_L:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_1_7_at_L:(Jessie_memory_model.memory doubleP
  R)): Prop := ((Jessie_memory_model.select doubleP_doubleM_q_0_9_at_L
  (Jessie_memory_model.shift q_0_0
  0%Z)) = (((((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  0%Z)))%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  1%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  2%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1 3%Z)))%R)%R) /\
  (((Jessie_memory_model.select doubleP_doubleM_q_0_9_at_L
  (Jessie_memory_model.shift q_0_0
  1%Z)) = (((((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  1%Z)))%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  0%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  3%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1 2%Z)))%R)%R) /\
  (((Jessie_memory_model.select doubleP_doubleM_q_0_9_at_L
  (Jessie_memory_model.shift q_0_0
  2%Z)) = (((((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  2%Z)))%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  3%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  0%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1 1%Z)))%R)%R) /\
  ((Jessie_memory_model.select doubleP_doubleM_q_0_9_at_L
  (Jessie_memory_model.shift q_0_0
  3%Z)) = (((((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  3%Z)))%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  2%Z)))%R)%R - ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1
  1%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q1_1_7_at_L
  (Jessie_memory_model.shift q1_1
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q2_1_8_at_L
  (Jessie_memory_model.shift q2_1 0%Z)))%R)%R))).

(* Why3 assumption *)
Definition left_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z.

Axiom pointer_addr_of_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (charP_of_pointer_address p))).

Axiom pointer_addr_of_doubleP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (doubleP_of_pointer_address p))).

Parameter unsigned_charP_of_pointer_address: (Jessie_memory_model.pointer
  unit) -> (Jessie_memory_model.pointer unsigned_charP).

Axiom pointer_addr_of_unsigned_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (unsigned_charP_of_pointer_address p))).

Parameter voidP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer voidP).

Axiom pointer_addr_of_voidP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (voidP_of_pointer_address p))).

(* Why3 assumption *)
Definition quat_eq (q1:(Jessie_memory_model.pointer doubleP))
  (q2:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q2_2_at_L2:(Jessie_memory_model.memory doubleP R))
  (doubleP_doubleM_q1_1_at_L1:(Jessie_memory_model.memory doubleP
  R)): Prop := ((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  0%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 0%Z))) /\
  (((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  1%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 1%Z))) /\
  (((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  2%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 2%Z))) /\
  ((Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  3%Z)) = (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 3%Z))))).

(* Why3 assumption *)
Definition quat_norm (q:(Jessie_memory_model.pointer doubleP))
  (doubleP_doubleM_q_5_at_L:(Jessie_memory_model.memory doubleP R)): R :=
  (sqrt (((((Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  0%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  0%Z)))%R + ((Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  1%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  1%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  2%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  2%Z)))%R)%R + ((Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q
  3%Z)) * (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q 3%Z)))%R)%R).

(* Why3 assumption *)
Definition right_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop :=
  (b <= (Jessie_memory_model.offset_max doubleP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition strict_valid_root_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_doubleP (p:(Jessie_memory_model.pointer
  doubleP)) (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

Parameter uint8_of_integer: Z -> uint8.

Axiom uint8_coerce : forall (x:Z), ((0%Z <= x)%Z /\ (x <= 255%Z)%Z) ->
  ((integer_of_uint8 (uint8_of_integer x)) = x).

Axiom uint8_extensionality : forall (x:uint8), forall (y:uint8),
  ((integer_of_uint8 x) = (integer_of_uint8 y)) -> (x = y).

Axiom uint8_range : forall (x:uint8), (0%Z <= (integer_of_uint8 x))%Z /\
  ((integer_of_uint8 x) <= 255%Z)%Z.

Parameter unsigned_charP_tag: (Jessie_memory_model.tag_id unsigned_charP).

Axiom unsigned_charP_int : ((Jessie_memory_model.int_of_tag unsigned_charP_tag) = 1%Z).

Axiom unsigned_charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  unsigned_charP)),
  (p = (unsigned_charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom unsigned_charP_parenttag_bottom : (Jessie_memory_model.parenttag
  unsigned_charP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id
  unsigned_charP))).

Axiom unsigned_charP_tags : forall (x:(Jessie_memory_model.pointer
  unsigned_charP)),
  forall (unsigned_charP_tag_table:(Jessie_memory_model.tag_table
  unsigned_charP)), (Jessie_memory_model.instanceof unsigned_charP_tag_table
  x unsigned_charP_tag).

(* Why3 assumption *)
Definition valid_root_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_doubleP (p:(Jessie_memory_model.pointer doubleP)) (a:Z)
  (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max doubleP_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_root_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_doubleP (p:(Jessie_memory_model.pointer doubleP))
  (a:Z) (b:Z) (doubleP_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)): Prop := ((Jessie_memory_model.offset_min doubleP_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max doubleP_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

Parameter voidP_tag: (Jessie_memory_model.tag_id voidP).

Axiom voidP_int : ((Jessie_memory_model.int_of_tag voidP_tag) = 1%Z).

Axiom voidP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  voidP)),
  (p = (voidP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom voidP_parenttag_bottom : (Jessie_memory_model.parenttag voidP_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id voidP))).

Axiom voidP_tags : forall (x:(Jessie_memory_model.pointer voidP)),
  forall (voidP_tag_table:(Jessie_memory_model.tag_table voidP)),
  (Jessie_memory_model.instanceof voidP_tag_table x voidP_tag).

Axiom div_unit : forall (x_1:R), (~ (x_1 = 0%R)) -> ((Rdiv x_1 x_1)%R = 1%R).

Axiom sum_square_pos : forall (a:R), forall (b:R), forall (c:R),
  forall (d:R),
  (0%R <= ((((a * a)%R + (b * b)%R)%R + (c * c)%R)%R + (d * d)%R)%R)%R.

Axiom norm_eq : forall (doubleP_doubleM_q2_0_17_at_L2:(Jessie_memory_model.memory
  doubleP R)),
  forall (doubleP_doubleM_q1_0_16_at_L1:(Jessie_memory_model.memory doubleP
  R)), forall (q1_0_0:(Jessie_memory_model.pointer doubleP)),
  forall (q2_0_0:(Jessie_memory_model.pointer doubleP)), (quat_eq q1_0_0
  q2_0_0 doubleP_doubleM_q2_0_17_at_L2 doubleP_doubleM_q1_0_16_at_L1) ->
  ((quat_norm q1_0_0 doubleP_doubleM_q1_0_16_at_L1) = (quat_norm q2_0_0
  doubleP_doubleM_q2_0_17_at_L2)).

Axiom norm_product : forall (doubleP_doubleM_q_1_20_at_L:(Jessie_memory_model.memory
  doubleP R)),
  forall (doubleP_doubleM_q2_2_19_at_L:(Jessie_memory_model.memory doubleP
  R)), forall (doubleP_doubleM_q1_2_18_at_L:(Jessie_memory_model.memory
  doubleP R)), forall (q1_2:(Jessie_memory_model.pointer doubleP)),
  forall (q2_2:(Jessie_memory_model.pointer doubleP)),
  forall (q_1_0:(Jessie_memory_model.pointer doubleP)), (is_product q1_2 q2_2
  q_1_0 doubleP_doubleM_q_1_20_at_L doubleP_doubleM_q2_2_19_at_L
  doubleP_doubleM_q1_2_18_at_L) -> ((quat_norm q_1_0
  doubleP_doubleM_q_1_20_at_L) = ((quat_norm q1_2
  doubleP_doubleM_q1_2_18_at_L) * (quat_norm q2_2
  doubleP_doubleM_q2_2_19_at_L))%R).

Axiom norm_div_scalar : forall (doubleP_doubleM_q_3_22_at_L:(Jessie_memory_model.memory
  doubleP R)),
  forall (doubleP_doubleM_q1_4_21_at_L1:(Jessie_memory_model.memory doubleP
  R)), forall (q1_4:(Jessie_memory_model.pointer doubleP)),
  forall (q_3:(Jessie_memory_model.pointer doubleP)), forall (f_0:R),
  (is_div_scalar q1_4 f_0 q_3 doubleP_doubleM_q_3_22_at_L
  doubleP_doubleM_q1_4_21_at_L1) -> ((quat_norm q_3
  doubleP_doubleM_q_3_22_at_L) = (Rdiv (quat_norm q1_4
  doubleP_doubleM_q1_4_21_at_L1) f_0)%R).

(* Why3 assumption *)
Inductive ref (a:Type) {a_WT:WhyType a} :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a] [a_WT]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

Parameter eq_unit: unit -> unit -> Prop.

Parameter neq_unit: unit -> unit -> Prop.

Parameter eq_bool: bool -> bool -> Prop.

Parameter neq_bool: bool -> bool -> Prop.

Parameter lt_int: Z -> Z -> Prop.

Parameter le_int: Z -> Z -> Prop.

Parameter gt_int: Z -> Z -> Prop.

Parameter ge_int: Z -> Z -> Prop.

Parameter eq_int: Z -> Z -> Prop.

Parameter neq_int: Z -> Z -> Prop.

Parameter add_int: Z -> Z -> Z.

Parameter sub_int: Z -> Z -> Z.

Parameter mul_int: Z -> Z -> Z.

Parameter neg_int: Z -> Z.

(* Why3 assumption *)
Definition zwf_zero (a:Z) (b:Z): Prop := (0%Z <= b)%Z /\ (a < b)%Z.

Parameter lt_int_bool: Z -> Z -> bool.

Parameter le_int_bool: Z -> Z -> bool.

Parameter gt_int_bool: Z -> Z -> bool.

Parameter ge_int_bool: Z -> Z -> bool.

Parameter eq_int_bool: Z -> Z -> bool.

Parameter neq_int_bool: Z -> Z -> bool.

Axiom Lt_int_bool_axiom : forall (x:Z), forall (y:Z), ((lt_int_bool x
  y) = true) <-> (x < y)%Z.

Axiom Le_int_bool_axiom : forall (x:Z), forall (y:Z), ((le_int_bool x
  y) = true) <-> (x <= y)%Z.

Axiom Gt_int_bool_axiom : forall (x:Z), forall (y:Z), ((gt_int_bool x
  y) = true) <-> (y < x)%Z.

Axiom Ge_int_bool_axiom : forall (x:Z), forall (y:Z), ((ge_int_bool x
  y) = true) <-> (y <= x)%Z.

Axiom Eq_int_bool_axiom : forall (x:Z), forall (y:Z), ((eq_int_bool x
  y) = true) <-> (x = y).

Axiom Neq_int_bool_axiom : forall (x:Z), forall (y:Z), ((neq_int_bool x
  y) = true) <-> ~ (x = y).

Parameter abs_int: Z -> Z.

Axiom Abs_int_pos : forall (x:Z), (0%Z <= x)%Z -> ((Zabs x) = x).

Axiom Abs_int_neg : forall (x:Z), (x <= 0%Z)%Z -> ((Zabs x) = (-x)%Z).

Parameter int_max: Z -> Z -> Z.

Parameter int_min: Z -> Z -> Z.

Axiom Int_max_is_ge : forall (x:Z), forall (y:Z), (x <= (int_max x y))%Z /\
  (y <= (int_max x y))%Z.

Axiom Int_max_is_some : forall (x:Z), forall (y:Z), ((int_max x y) = x) \/
  ((int_max x y) = y).

Axiom Int_min_is_le : forall (x:Z), forall (y:Z), ((int_min x y) <= x)%Z /\
  ((int_min x y) <= y)%Z.

Axiom Int_min_is_some : forall (x:Z), forall (y:Z), ((int_min x y) = x) \/
  ((int_min x y) = y).

Require Import Why3.

(* Why3 goal *)
Theorem WP_parameter_random_unit_quat_ensures_default : forall (q_1:(Jessie_memory_model.pointer
  doubleP)) (doubleP_q_1_15_alloc_table:(Jessie_memory_model.alloc_table
  doubleP)), forall (doubleP_doubleM_q_1_15:(Jessie_memory_model.memory
  doubleP R)), (((Jessie_memory_model.offset_min doubleP_q_1_15_alloc_table
  q_1) <= 0%Z)%Z /\
  (3%Z <= (Jessie_memory_model.offset_max doubleP_q_1_15_alloc_table
  q_1))%Z) -> forall (o:int32), ((integer_of_int32 o) = 0%Z) ->
  forall (i:int32), (i = o) -> forall (i1:int32)
  (doubleP_doubleM_q_1_151:(Jessie_memory_model.memory doubleP R)),
  (((0%Z <= (integer_of_int32 i1))%Z /\ ((integer_of_int32 i1) <= 4%Z)%Z) /\
  (Jessie_memory_model.not_assigns doubleP_q_1_15_alloc_table
  doubleP_doubleM_q_1_15 doubleP_doubleM_q_1_151
  (Jessie_memory_model.pset_range (Jessie_memory_model.pset_singleton q_1)
  0%Z 3%Z))) -> ((~ ((integer_of_int32 i1) < 4%Z)%Z) -> forall (norm:R),
  (norm = (quat_norm q_1 doubleP_doubleM_q_1_151)) -> ((0%R < norm)%R ->
  forall (o1:int32), ((integer_of_int32 o1) = 0%Z) -> forall (i2:int32),
  (i2 = o1) -> forall (i3:int32)
  (doubleP_doubleM_q_1_152:(Jessie_memory_model.memory doubleP R)),
  (((forall (j_1:Z), (((integer_of_int32 i3) <= j_1)%Z /\ (j_1 < 4%Z)%Z) ->
  ((Jessie_memory_model.select doubleP_doubleM_q_1_152
  (Jessie_memory_model.shift q_1
  j_1)) = (Jessie_memory_model.select doubleP_doubleM_q_1_151
  (Jessie_memory_model.shift q_1 j_1)))) /\ ((forall (j_0:Z),
  ((0%Z <= j_0)%Z /\ (j_0 < (integer_of_int32 i3))%Z) ->
  ((Jessie_memory_model.select doubleP_doubleM_q_1_152
  (Jessie_memory_model.shift q_1
  j_0)) = (Rdiv (Jessie_memory_model.select doubleP_doubleM_q_1_151
  (Jessie_memory_model.shift q_1 j_0)) norm)%R)) /\
  ((0%Z <= (integer_of_int32 i3))%Z /\ ((integer_of_int32 i3) <= 4%Z)%Z))) /\
  (Jessie_memory_model.not_assigns doubleP_q_1_15_alloc_table
  doubleP_doubleM_q_1_15 doubleP_doubleM_q_1_152
  (Jessie_memory_model.pset_range (Jessie_memory_model.pset_singleton q_1)
  0%Z 3%Z))) -> ((~ ((integer_of_int32 i3) < 4%Z)%Z) -> ((is_div_scalar q_1
  norm q_1 doubleP_doubleM_q_1_152 doubleP_doubleM_q_1_151) ->
  ((quat_norm q_1 doubleP_doubleM_q_1_152) = 1%R))))).
intros q_1 doubleP_q_1_15_alloc_table doubleP_doubleM_q_1_15 (h1,h2) o h3 i
h4 i1 doubleP_doubleM_q_1_151 ((h5,h6),h7) h8 norm h9 h10 o1 h11 i2 h12 i3
doubleP_doubleM_q_1_152 ((h13,(h14,(h15,h16))),h17) h18 h19.
rewrite norm_div_scalar with (1:=h19).
why3 "Alt-Ergo,0.95," timelimit 3.
Qed.


