(* This file is generated by Why3's Coq 8.4 driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require Reals.R_sqrt.
Require Reals.Rfunctions.
Require Reals.Rbasic_fun.
Require BuiltIn.
Require int.Int.
Require bool.Bool.
Require real.Real.
Require real.RealInfix.
Require real.Abs.
Require real.FromInt.
Require real.Square.
Require real.PowerInt.
Require floating_point.Rounding.
Require floating_point.SingleFormat.
Require floating_point.DoubleFormat.
Require floating_point.Single.
Require floating_point.Double.
Require Jessie_memory_model.

Axiom charP : Type.
Parameter charP_WhyType : WhyType charP.
Existing Instance charP_WhyType.

Axiom doubleP : Type.
Parameter doubleP_WhyType : WhyType doubleP.
Existing Instance doubleP_WhyType.

Axiom int32 : Type.
Parameter int32_WhyType : WhyType int32.
Existing Instance int32_WhyType.

Axiom int8 : Type.
Parameter int8_WhyType : WhyType int8.
Existing Instance int8_WhyType.

Axiom padding : Type.
Parameter padding_WhyType : WhyType padding.
Existing Instance padding_WhyType.

Axiom uint8 : Type.
Parameter uint8_WhyType : WhyType uint8.
Existing Instance uint8_WhyType.

Axiom unsigned_charP : Type.
Parameter unsigned_charP_WhyType : WhyType unsigned_charP.
Existing Instance unsigned_charP_WhyType.

Axiom voidP : Type.
Parameter voidP_WhyType : WhyType voidP.
Existing Instance voidP_WhyType.

(* Why3 assumption *)
Definition bounded (x_0_0:R) (k:R): Prop := ((-k)%R <= x_0_0)%R /\
  (x_0_0 <= k)%R.

Parameter charP_tag: (@Jessie_memory_model.tag_id charP charP_WhyType).

Axiom charP_int : ((Jessie_memory_model.int_of_tag charP_tag) = 1%Z).

Parameter charP_of_pointer_address: (@Jessie_memory_model.pointer unit _) ->
  (@Jessie_memory_model.pointer charP charP_WhyType).

Axiom charP_of_pointer_address_of_pointer_addr : forall (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)),
  (p = (charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom charP_parenttag_bottom : (Jessie_memory_model.parenttag charP_tag
  (Jessie_memory_model.bottom_tag : (@Jessie_memory_model.tag_id
  charP charP_WhyType))).

Axiom charP_tags : forall (x:(@Jessie_memory_model.pointer
  charP charP_WhyType)),
  forall (charP_tag_table:(@Jessie_memory_model.tag_table
  charP charP_WhyType)), (Jessie_memory_model.instanceof charP_tag_table x
  charP_tag).

(* Why3 assumption *)
Definition norm2 (p1:R) (p2:R) (p3:R) (p4:R): R :=
  ((((p1 * p1)%R + (p2 * p2)%R)%R + (p3 * p3)%R)%R + (p4 * p4)%R)%R.

(* Why3 assumption *)
Definition distance2 (p0:R) (p1_3:R) (p2_3:R) (p3_3:R) (q0:R) (q1_0:R)
  (q2_0:R) (q3:R): R := (norm2 (q0 - p0)%R (q1_0 - p1_3)%R (q2_0 - p2_3)%R
  (q3 - p3_3)%R).

(* Why3 assumption *)
Definition distance_quat_vect (q_1:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (p0_1:R) (p1_5:R) (p2_5:R) (p3_5:R)
  (doubleP_doubleM_q_1_6_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): R :=
  (Reals.R_sqrt.sqrt (distance2 (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_1_6_at_L
  (Jessie_memory_model.shift q_1 0%Z)))
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_1_6_at_L
  (Jessie_memory_model.shift q_1 1%Z)))
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_1_6_at_L
  (Jessie_memory_model.shift q_1 2%Z)))
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_1_6_at_L
  (Jessie_memory_model.shift q_1 3%Z))) p0_1 p1_5 p2_5 p3_5)).

Parameter doubleP_tag: (@Jessie_memory_model.tag_id doubleP doubleP_WhyType).

Axiom doubleP_int : ((Jessie_memory_model.int_of_tag doubleP_tag) = 1%Z).

Parameter doubleP_of_pointer_address: (@Jessie_memory_model.pointer
  unit _) -> (@Jessie_memory_model.pointer doubleP doubleP_WhyType).

Axiom doubleP_of_pointer_address_of_pointer_addr : forall (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)),
  (p = (doubleP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom doubleP_parenttag_bottom : (Jessie_memory_model.parenttag doubleP_tag
  (Jessie_memory_model.bottom_tag : (@Jessie_memory_model.tag_id
  doubleP doubleP_WhyType))).

Axiom doubleP_tags : forall (x:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)),
  forall (doubleP_tag_table:(@Jessie_memory_model.tag_table
  doubleP doubleP_WhyType)), (Jessie_memory_model.instanceof
  doubleP_tag_table x doubleP_tag).

Parameter integer_of_int32: int32 -> Z.

(* Why3 assumption *)
Definition eq_int32 (x:int32) (y:int32): Prop :=
  ((integer_of_int32 x) = (integer_of_int32 y)).

Parameter integer_of_int8: int8 -> Z.

(* Why3 assumption *)
Definition eq_int8 (x:int8) (y:int8): Prop :=
  ((integer_of_int8 x) = (integer_of_int8 y)).

Parameter integer_of_uint8: uint8 -> Z.

(* Why3 assumption *)
Definition eq_uint8 (x:uint8) (y:uint8): Prop :=
  ((integer_of_uint8 x) = (integer_of_uint8 y)).

Parameter int32_of_integer: Z -> int32.

Axiom int32_coerce : forall (x:Z), (((-2147483648%Z)%Z <= x)%Z /\
  (x <= 2147483647%Z)%Z) -> ((integer_of_int32 (int32_of_integer x)) = x).

Axiom int32_extensionality : forall (x:int32), forall (y:int32),
  ((integer_of_int32 x) = (integer_of_int32 y)) -> (x = y).

Axiom int32_range : forall (x:int32),
  ((-2147483648%Z)%Z <= (integer_of_int32 x))%Z /\
  ((integer_of_int32 x) <= 2147483647%Z)%Z.

Parameter int8_of_integer: Z -> int8.

Axiom int8_coerce : forall (x:Z), (((-128%Z)%Z <= x)%Z /\ (x <= 127%Z)%Z) ->
  ((integer_of_int8 (int8_of_integer x)) = x).

Axiom int8_extensionality : forall (x:int8), forall (y:int8),
  ((integer_of_int8 x) = (integer_of_int8 y)) -> (x = y).

Axiom int8_range : forall (x:int8), ((-128%Z)%Z <= (integer_of_int8 x))%Z /\
  ((integer_of_int8 x) <= 127%Z)%Z.

(* Why3 assumption *)
Definition left_valid_struct_charP (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)) (a:Z)
  (charP_alloc_table:(@Jessie_memory_model.alloc_table
  charP charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_doubleP (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (a:Z)
  (doubleP_alloc_table:(@Jessie_memory_model.alloc_table
  doubleP doubleP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min doubleP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_unsigned_charP (p:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)) (a:Z)
  (unsigned_charP_alloc_table:(@Jessie_memory_model.alloc_table
  unsigned_charP unsigned_charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_voidP (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)) (a:Z)
  (voidP_alloc_table:(@Jessie_memory_model.alloc_table
  voidP voidP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition norm_vect (p1_1:R) (p2_1:R) (p3_1:R) (p4_1:R): R :=
  (Reals.R_sqrt.sqrt (norm2 p1_1 p2_1 p3_1 p4_1)).

Axiom pointer_addr_of_charP_of_pointer_address : forall (p:(@Jessie_memory_model.pointer
  unit _)),
  (p = (Jessie_memory_model.pointer_address (charP_of_pointer_address p))).

Axiom pointer_addr_of_doubleP_of_pointer_address : forall (p:(@Jessie_memory_model.pointer
  unit _)),
  (p = (Jessie_memory_model.pointer_address (doubleP_of_pointer_address p))).

Parameter unsigned_charP_of_pointer_address: (@Jessie_memory_model.pointer
  unit _) -> (@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType).

Axiom pointer_addr_of_unsigned_charP_of_pointer_address : forall (p:(@Jessie_memory_model.pointer
  unit _)),
  (p = (Jessie_memory_model.pointer_address (unsigned_charP_of_pointer_address p))).

Parameter voidP_of_pointer_address: (@Jessie_memory_model.pointer unit _) ->
  (@Jessie_memory_model.pointer voidP voidP_WhyType).

Axiom pointer_addr_of_voidP_of_pointer_address : forall (p:(@Jessie_memory_model.pointer
  unit _)),
  (p = (Jessie_memory_model.pointer_address (voidP_of_pointer_address p))).

Parameter power: R -> Z -> R.

(* Why3 assumption *)
Definition product1 (q1_2:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (q2_2:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType))
  (doubleP_doubleM_q2_2_8_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType))
  (doubleP_doubleM_q1_2_7_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): R :=
  (((((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_2_7_at_L
  (Jessie_memory_model.shift q1_2
  0%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_8_at_L
  (Jessie_memory_model.shift q2_2
  0%Z))))%R - ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_2_7_at_L
  (Jessie_memory_model.shift q1_2
  1%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_8_at_L
  (Jessie_memory_model.shift q2_2
  1%Z))))%R)%R - ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_2_7_at_L
  (Jessie_memory_model.shift q1_2
  2%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_8_at_L
  (Jessie_memory_model.shift q2_2
  2%Z))))%R)%R - ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_2_7_at_L
  (Jessie_memory_model.shift q1_2
  3%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_8_at_L
  (Jessie_memory_model.shift q2_2 3%Z))))%R)%R.

(* Why3 assumption *)
Definition product2 (q1_3:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (q2_3:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType))
  (doubleP_doubleM_q2_3_10_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType))
  (doubleP_doubleM_q1_3_9_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): R :=
  (((((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_3_9_at_L
  (Jessie_memory_model.shift q1_3
  0%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_3_10_at_L
  (Jessie_memory_model.shift q2_3
  1%Z))))%R + ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_3_9_at_L
  (Jessie_memory_model.shift q1_3
  1%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_3_10_at_L
  (Jessie_memory_model.shift q2_3
  0%Z))))%R)%R + ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_3_9_at_L
  (Jessie_memory_model.shift q1_3
  2%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_3_10_at_L
  (Jessie_memory_model.shift q2_3
  3%Z))))%R)%R - ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_3_9_at_L
  (Jessie_memory_model.shift q1_3
  3%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_3_10_at_L
  (Jessie_memory_model.shift q2_3 2%Z))))%R)%R.

(* Why3 assumption *)
Definition product3 (q1_4:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (q2_4:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType))
  (doubleP_doubleM_q2_4_12_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType))
  (doubleP_doubleM_q1_4_11_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): R :=
  (((((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_4_11_at_L
  (Jessie_memory_model.shift q1_4
  0%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_4_12_at_L
  (Jessie_memory_model.shift q2_4
  2%Z))))%R - ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_4_11_at_L
  (Jessie_memory_model.shift q1_4
  1%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_4_12_at_L
  (Jessie_memory_model.shift q2_4
  3%Z))))%R)%R + ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_4_11_at_L
  (Jessie_memory_model.shift q1_4
  2%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_4_12_at_L
  (Jessie_memory_model.shift q2_4
  0%Z))))%R)%R + ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_4_11_at_L
  (Jessie_memory_model.shift q1_4
  3%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_4_12_at_L
  (Jessie_memory_model.shift q2_4 1%Z))))%R)%R.

(* Why3 assumption *)
Definition product4 (q1_5:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (q2_5:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType))
  (doubleP_doubleM_q2_5_14_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType))
  (doubleP_doubleM_q1_5_13_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): R :=
  (((((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_5_13_at_L
  (Jessie_memory_model.shift q1_5
  0%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_5_14_at_L
  (Jessie_memory_model.shift q2_5
  3%Z))))%R + ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_5_13_at_L
  (Jessie_memory_model.shift q1_5
  1%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_5_14_at_L
  (Jessie_memory_model.shift q2_5
  2%Z))))%R)%R - ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_5_13_at_L
  (Jessie_memory_model.shift q1_5
  2%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_5_14_at_L
  (Jessie_memory_model.shift q2_5
  1%Z))))%R)%R + ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_5_13_at_L
  (Jessie_memory_model.shift q1_5
  3%Z))) * (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_5_14_at_L
  (Jessie_memory_model.shift q2_5 0%Z))))%R)%R.

(* Why3 assumption *)
Definition quat_eq (q1:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (q2:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType))
  (doubleP_doubleM_q2_2_at_L2:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType))
  (doubleP_doubleM_q1_1_at_L1:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): Prop :=
  ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  0%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 0%Z)))) /\
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  1%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 1%Z)))) /\
  (((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  2%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 2%Z)))) /\
  ((floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q1_1_at_L1
  (Jessie_memory_model.shift q1
  3%Z))) = (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q2_2_at_L2
  (Jessie_memory_model.shift q2 3%Z)))))).

(* Why3 assumption *)
Definition quat_norm (q:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType))
  (doubleP_doubleM_q_5_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)): R :=
  (norm_vect (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q 0%Z)))
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q 1%Z)))
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q 2%Z)))
  (floating_point.Double.value (Jessie_memory_model.select doubleP_doubleM_q_5_at_L
  (Jessie_memory_model.shift q 3%Z)))).

(* Why3 assumption *)
Definition right_valid_struct_charP (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)) (b:Z)
  (charP_alloc_table:(@Jessie_memory_model.alloc_table
  charP charP_WhyType)): Prop :=
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_doubleP (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (b:Z)
  (doubleP_alloc_table:(@Jessie_memory_model.alloc_table
  doubleP doubleP_WhyType)): Prop :=
  (b <= (Jessie_memory_model.offset_max doubleP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_unsigned_charP (p:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)) (b:Z)
  (unsigned_charP_alloc_table:(@Jessie_memory_model.alloc_table
  unsigned_charP unsigned_charP_WhyType)): Prop :=
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_voidP (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)) (b:Z)
  (voidP_alloc_table:(@Jessie_memory_model.alloc_table
  voidP voidP_WhyType)): Prop :=
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition strict_valid_root_charP (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)) (a:Z) (b:Z)
  (charP_alloc_table:(@Jessie_memory_model.alloc_table
  charP charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_doubleP (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (a:Z) (b:Z)
  (doubleP_alloc_table:(@Jessie_memory_model.alloc_table
  doubleP doubleP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min doubleP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_unsigned_charP (p:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(@Jessie_memory_model.alloc_table
  unsigned_charP unsigned_charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_voidP (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)) (a:Z) (b:Z)
  (voidP_alloc_table:(@Jessie_memory_model.alloc_table
  voidP voidP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_charP (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)) (a:Z) (b:Z)
  (charP_alloc_table:(@Jessie_memory_model.alloc_table
  charP charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_doubleP (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (a:Z) (b:Z)
  (doubleP_alloc_table:(@Jessie_memory_model.alloc_table
  doubleP doubleP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min doubleP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max doubleP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_unsigned_charP
  (p:(@Jessie_memory_model.pointer unsigned_charP unsigned_charP_WhyType))
  (a:Z) (b:Z) (unsigned_charP_alloc_table:(@Jessie_memory_model.alloc_table
  unsigned_charP unsigned_charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_voidP (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)) (a:Z) (b:Z)
  (voidP_alloc_table:(@Jessie_memory_model.alloc_table
  voidP voidP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

Parameter uint8_of_integer: Z -> uint8.

Axiom uint8_coerce : forall (x:Z), ((0%Z <= x)%Z /\ (x <= 255%Z)%Z) ->
  ((integer_of_uint8 (uint8_of_integer x)) = x).

Axiom uint8_extensionality : forall (x:uint8), forall (y:uint8),
  ((integer_of_uint8 x) = (integer_of_uint8 y)) -> (x = y).

Axiom uint8_range : forall (x:uint8), (0%Z <= (integer_of_uint8 x))%Z /\
  ((integer_of_uint8 x) <= 255%Z)%Z.

Parameter unsigned_charP_tag: (@Jessie_memory_model.tag_id
  unsigned_charP unsigned_charP_WhyType).

Axiom unsigned_charP_int : ((Jessie_memory_model.int_of_tag unsigned_charP_tag) = 1%Z).

Axiom unsigned_charP_of_pointer_address_of_pointer_addr : forall (p:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)),
  (p = (unsigned_charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom unsigned_charP_parenttag_bottom : (Jessie_memory_model.parenttag
  unsigned_charP_tag
  (Jessie_memory_model.bottom_tag : (@Jessie_memory_model.tag_id
  unsigned_charP unsigned_charP_WhyType))).

Axiom unsigned_charP_tags : forall (x:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)),
  forall (unsigned_charP_tag_table:(@Jessie_memory_model.tag_table
  unsigned_charP unsigned_charP_WhyType)), (Jessie_memory_model.instanceof
  unsigned_charP_tag_table x unsigned_charP_tag).

(* Why3 assumption *)
Definition valid_root_charP (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)) (a:Z) (b:Z)
  (charP_alloc_table:(@Jessie_memory_model.alloc_table
  charP charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_doubleP (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (a:Z) (b:Z)
  (doubleP_alloc_table:(@Jessie_memory_model.alloc_table
  doubleP doubleP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min doubleP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max doubleP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_unsigned_charP (p:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(@Jessie_memory_model.alloc_table
  unsigned_charP unsigned_charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_voidP (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)) (a:Z) (b:Z)
  (voidP_alloc_table:(@Jessie_memory_model.alloc_table
  voidP voidP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_charP (p:(@Jessie_memory_model.pointer
  charP charP_WhyType)) (a:Z) (b:Z)
  (charP_alloc_table:(@Jessie_memory_model.alloc_table
  charP charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_doubleP (p:(@Jessie_memory_model.pointer
  doubleP doubleP_WhyType)) (a:Z) (b:Z)
  (doubleP_alloc_table:(@Jessie_memory_model.alloc_table
  doubleP doubleP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min doubleP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max doubleP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_unsigned_charP (p:(@Jessie_memory_model.pointer
  unsigned_charP unsigned_charP_WhyType)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(@Jessie_memory_model.alloc_table
  unsigned_charP unsigned_charP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_voidP (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)) (a:Z) (b:Z)
  (voidP_alloc_table:(@Jessie_memory_model.alloc_table
  voidP voidP_WhyType)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

Parameter voidP_tag: (@Jessie_memory_model.tag_id voidP voidP_WhyType).

Axiom voidP_int : ((Jessie_memory_model.int_of_tag voidP_tag) = 1%Z).

Axiom voidP_of_pointer_address_of_pointer_addr : forall (p:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)),
  (p = (voidP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom voidP_parenttag_bottom : (Jessie_memory_model.parenttag voidP_tag
  (Jessie_memory_model.bottom_tag : (@Jessie_memory_model.tag_id
  voidP voidP_WhyType))).

Axiom voidP_tags : forall (x:(@Jessie_memory_model.pointer
  voidP voidP_WhyType)),
  forall (voidP_tag_table:(@Jessie_memory_model.tag_table
  voidP voidP_WhyType)), (Jessie_memory_model.instanceof voidP_tag_table x
  voidP_tag).

Axiom norm2_pos : forall (p1_0:R), forall (p2_0:R), forall (p3_0:R),
  forall (p4_0:R), (0%R <= (norm2 p1_0 p2_0 p3_0 p4_0))%R.

Axiom norm_vect_pos : forall (p1_2:R), forall (p2_2:R), forall (p3_2:R),
  forall (p4_2:R), (0%R <= (norm_vect p1_2 p2_2 p3_2 p4_2))%R.

Axiom quat_norm_pos : forall (doubleP_doubleM_q_0_19_at_L:(@Jessie_memory_model.memory
  doubleP doubleP_WhyType
  floating_point.DoubleFormat.double floating_point.DoubleFormat.double_WhyType)),
  forall (q_0_1:(@Jessie_memory_model.pointer doubleP doubleP_WhyType)),
  (0%R <= (quat_norm q_0_1 doubleP_doubleM_q_0_19_at_L))%R.

Axiom distance2_sym : forall (p0_0:R), forall (p1_4:R), forall (p2_4:R),
  forall (p3_4:R), forall (q0_0:R), forall (q1_1_0:R), forall (q2_1_0:R),
  forall (q3_0:R), ((norm2 (q0_0 - p0_0)%R (q1_1_0 - p1_4)%R
  (q2_1_0 - p2_4)%R (q3_0 - p3_4)%R) = (norm2 (p0_0 - q0_0)%R
  (p1_4 - q1_1_0)%R (p2_4 - q2_1_0)%R (p3_4 - q3_0)%R)).

(* Why3 goal *)
Theorem bounded_sqr : forall (x_1:R), forall (k_0:R), ((0%R <= k_0)%R /\
  ((x_1 * x_1)%R <= (k_0 * k_0)%R)%R) -> (bounded x_1 k_0).
(* Why3 intros x_1 k_0 (h1,h2). *)
intros x_2 k_0 (h1,h2).
split.
apply R_sqr.Rsqr_neg_pos_le_0; auto.
apply R_sqr.Rsqr_incr_0_var; auto.
Qed.

