(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require bool.Bool.
Require Jessie_memory_model.

Axiom charP : Type.
Parameter charP_WhyType : WhyType charP.
Existing Instance charP_WhyType.

Axiom intP : Type.
Parameter intP_WhyType : WhyType intP.
Existing Instance intP_WhyType.

Axiom padding : Type.
Parameter padding_WhyType : WhyType padding.
Existing Instance padding_WhyType.

Axiom unsigned_charP : Type.
Parameter unsigned_charP_WhyType : WhyType unsigned_charP.
Existing Instance unsigned_charP_WhyType.

Axiom voidP : Type.
Parameter voidP_WhyType : WhyType voidP.
Existing Instance voidP_WhyType.

Parameter charP_tag: (Jessie_memory_model.tag_id charP).

Axiom charP_int : ((Jessie_memory_model.int_of_tag charP_tag) = 1%Z).

Parameter charP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer charP).

Axiom charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  charP)),
  (p = (charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom charP_parenttag_bottom : (Jessie_memory_model.parenttag charP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id charP))).

Axiom charP_tags : forall (x:(Jessie_memory_model.pointer charP)),
  forall (charP_tag_table:(Jessie_memory_model.tag_table charP)),
  (Jessie_memory_model.instanceof charP_tag_table x charP_tag).

Parameter intP_tag: (Jessie_memory_model.tag_id intP).

Axiom intP_int : ((Jessie_memory_model.int_of_tag intP_tag) = 1%Z).

Parameter intP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer intP).

Axiom intP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  intP)),
  (p = (intP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom intP_parenttag_bottom : (Jessie_memory_model.parenttag intP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id intP))).

Axiom intP_tags : forall (x:(Jessie_memory_model.pointer intP)),
  forall (intP_tag_table:(Jessie_memory_model.tag_table intP)),
  (Jessie_memory_model.instanceof intP_tag_table x intP_tag).

(* Why3 assumption *)
Definition left_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_intP (p:(Jessie_memory_model.pointer intP))
  (a:Z) (intP_alloc_table:(Jessie_memory_model.alloc_table intP)): Prop :=
  ((Jessie_memory_model.offset_min intP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z.

Parameter sum: (Jessie_memory_model.pointer intP) -> Z -> Z ->
  (Jessie_memory_model.memory intP Z) -> Z.

Axiom no_assign_sum_0 : forall (tmp:(Jessie_memory_model.pset intP)),
  forall (tmpmem:(Jessie_memory_model.memory intP Z)),
  forall (tmpalloc:(Jessie_memory_model.alloc_table intP)),
  forall (intP_intM_t_1_at_L:(Jessie_memory_model.memory intP Z)),
  forall (j_0:Z), forall (i_1:Z), forall (t:(Jessie_memory_model.pointer
  intP)), ((Jessie_memory_model.pset_disjoint tmp
  (Jessie_memory_model.pset_all (Jessie_memory_model.pset_singleton t))) /\
  (Jessie_memory_model.not_assigns tmpalloc intP_intM_t_1_at_L tmpmem
  tmp)) -> ((sum t i_1 j_0 intP_intM_t_1_at_L) = (sum t i_1 j_0 tmpmem)).

Axiom no_update_sum_0 : forall (tmp:(Jessie_memory_model.pointer intP)),
  forall (tmpval:Z), forall (intP_intM_t_1_at_L:(Jessie_memory_model.memory
  intP Z)), forall (j_0:Z), forall (i_1:Z),
  forall (t:(Jessie_memory_model.pointer intP)),
  (~ (Jessie_memory_model.in_pset tmp
  (Jessie_memory_model.pset_all (Jessie_memory_model.pset_singleton t)))) ->
  ((sum t i_1 j_0 intP_intM_t_1_at_L) = (sum t i_1 j_0
  (Jessie_memory_model.store intP_intM_t_1_at_L tmp tmpval))).

Axiom pointer_addr_of_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (charP_of_pointer_address p))).

Axiom pointer_addr_of_intP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (intP_of_pointer_address p))).

Parameter unsigned_charP_of_pointer_address: (Jessie_memory_model.pointer
  unit) -> (Jessie_memory_model.pointer unsigned_charP).

Axiom pointer_addr_of_unsigned_charP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (unsigned_charP_of_pointer_address p))).

Parameter voidP_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer voidP).

Axiom pointer_addr_of_voidP_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (voidP_of_pointer_address p))).

(* Why3 assumption *)
Definition right_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_intP (p:(Jessie_memory_model.pointer intP))
  (b:Z) (intP_alloc_table:(Jessie_memory_model.alloc_table intP)): Prop :=
  (b <= (Jessie_memory_model.offset_max intP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition strict_valid_root_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_intP (p:(Jessie_memory_model.pointer intP))
  (a:Z) (b:Z) (intP_alloc_table:(Jessie_memory_model.alloc_table
  intP)): Prop := ((Jessie_memory_model.offset_min intP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max intP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_charP (p:(Jessie_memory_model.pointer charP))
  (a:Z) (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table
  charP)): Prop := ((Jessie_memory_model.offset_min charP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_intP (p:(Jessie_memory_model.pointer intP))
  (a:Z) (b:Z) (intP_alloc_table:(Jessie_memory_model.alloc_table
  intP)): Prop := ((Jessie_memory_model.offset_min intP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max intP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max unsigned_charP_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_voidP (p:(Jessie_memory_model.pointer voidP))
  (a:Z) (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table
  voidP)): Prop := ((Jessie_memory_model.offset_min voidP_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max voidP_alloc_table p) = b).

Parameter unsigned_charP_tag: (Jessie_memory_model.tag_id unsigned_charP).

Axiom unsigned_charP_int : ((Jessie_memory_model.int_of_tag unsigned_charP_tag) = 1%Z).

Axiom unsigned_charP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  unsigned_charP)),
  (p = (unsigned_charP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom unsigned_charP_parenttag_bottom : (Jessie_memory_model.parenttag
  unsigned_charP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id
  unsigned_charP))).

Axiom unsigned_charP_tags : forall (x:(Jessie_memory_model.pointer
  unsigned_charP)),
  forall (unsigned_charP_tag_table:(Jessie_memory_model.tag_table
  unsigned_charP)), (Jessie_memory_model.instanceof unsigned_charP_tag_table
  x unsigned_charP_tag).

(* Why3 assumption *)
Definition valid_root_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_intP (p:(Jessie_memory_model.pointer intP)) (a:Z) (b:Z)
  (intP_alloc_table:(Jessie_memory_model.alloc_table intP)): Prop :=
  ((Jessie_memory_model.offset_min intP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max intP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_root_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_charP (p:(Jessie_memory_model.pointer charP)) (a:Z)
  (b:Z) (charP_alloc_table:(Jessie_memory_model.alloc_table charP)): Prop :=
  ((Jessie_memory_model.offset_min charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_intP (p:(Jessie_memory_model.pointer intP)) (a:Z)
  (b:Z) (intP_alloc_table:(Jessie_memory_model.alloc_table intP)): Prop :=
  ((Jessie_memory_model.offset_min intP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max intP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_unsigned_charP (p:(Jessie_memory_model.pointer
  unsigned_charP)) (a:Z) (b:Z)
  (unsigned_charP_alloc_table:(Jessie_memory_model.alloc_table
  unsigned_charP)): Prop :=
  ((Jessie_memory_model.offset_min unsigned_charP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max unsigned_charP_alloc_table p))%Z.

(* Why3 assumption *)
Definition valid_struct_voidP (p:(Jessie_memory_model.pointer voidP)) (a:Z)
  (b:Z) (voidP_alloc_table:(Jessie_memory_model.alloc_table voidP)): Prop :=
  ((Jessie_memory_model.offset_min voidP_alloc_table p) <= a)%Z /\
  (b <= (Jessie_memory_model.offset_max voidP_alloc_table p))%Z.

Parameter voidP_tag: (Jessie_memory_model.tag_id voidP).

Axiom voidP_int : ((Jessie_memory_model.int_of_tag voidP_tag) = 1%Z).

Axiom voidP_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  voidP)),
  (p = (voidP_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom voidP_parenttag_bottom : (Jessie_memory_model.parenttag voidP_tag
  (Jessie_memory_model.bottom_tag : (Jessie_memory_model.tag_id voidP))).

Axiom voidP_tags : forall (x:(Jessie_memory_model.pointer voidP)),
  forall (voidP_tag_table:(Jessie_memory_model.tag_table voidP)),
  (Jessie_memory_model.instanceof voidP_tag_table x voidP_tag).

Axiom sum1 : forall (intP_intM_t_1_at_L:(Jessie_memory_model.memory intP Z)),
  forall (t_0_1:(Jessie_memory_model.pointer intP)), forall (i_2:Z),
  forall (j_1:Z), (j_1 <= i_2)%Z -> ((sum t_0_1 i_2 j_1
  intP_intM_t_1_at_L) = 0%Z).

Axiom sum2 : forall (intP_intM_t_1_at_L:(Jessie_memory_model.memory intP Z)),
  forall (t_1:(Jessie_memory_model.pointer intP)), forall (i_3:Z),
  forall (j_2:Z), (i_3 <= j_2)%Z -> ((sum t_1 i_3 (j_2 + 1%Z)%Z
  intP_intM_t_1_at_L) = ((sum t_1 i_3 j_2
  intP_intM_t_1_at_L) + (Jessie_memory_model.select intP_intM_t_1_at_L
  (Jessie_memory_model.shift t_1 j_2)))%Z).

Axiom sum3 : forall (intP_intM_t_2_6_at_L:(Jessie_memory_model.memory intP
  Z)), forall (t_2:(Jessie_memory_model.pointer intP)), forall (i_4:Z),
  forall (j_3:Z), forall (k:Z), ((i_4 <= j_3)%Z /\ (j_3 <= k)%Z) -> ((sum t_2
  i_4 k intP_intM_t_2_6_at_L) = ((sum t_2 i_4 j_3
  intP_intM_t_2_6_at_L) + (sum t_2 j_3 k intP_intM_t_2_6_at_L))%Z).

Require Import Why3.

(* Why3 goal *)
Theorem sum_footprint : forall (intP_intM_t2_8_at_L:(Jessie_memory_model.memory
  intP Z)), forall (intP_intM_t1_7_at_L:(Jessie_memory_model.memory intP Z)),
  forall (t1:(Jessie_memory_model.pointer intP)),
  forall (t2:(Jessie_memory_model.pointer intP)), forall (i_5:Z),
  forall (j_4:Z), (forall (k_0:Z), ((i_5 <= k_0)%Z /\ (k_0 < j_4)%Z) ->
  ((Jessie_memory_model.select intP_intM_t1_7_at_L
  (Jessie_memory_model.shift t1
  k_0)) = (Jessie_memory_model.select intP_intM_t2_8_at_L
  (Jessie_memory_model.shift t2 k_0)))) -> ((sum t1 i_5 j_4
  intP_intM_t1_7_at_L) = (sum t2 i_5 j_4 intP_intM_t2_8_at_L)).
(* Why3 intros intP_intM_t2_8_at_L intP_intM_t1_7_at_L t1 t2 i_5 j_4 h1. *)
intros Mem1 Mem2 t1 t2 i j.
assert (h:(i > j \/ i <= j)%Z) by omega.
destruct h.
why3 "Alt-Ergo,1.30," timelimit 2; admit.
generalize H.
apply Zlt_lower_bound_ind with
  (P:= fun j => (i <= j)%Z -> (forall k_0 : int,
 (i <= k_0 < j)%Z ->
 Jessie_memory_model.select Mem2 (Jessie_memory_model.shift t1 k_0) =
 Jessie_memory_model.select Mem1 (Jessie_memory_model.shift t2 k_0)) ->
 sum t1 i j Mem2 = sum t2 i j Mem1)
  (z:=i); auto.
intros.
assert (h:(i = x \/ i < x)%Z) by omega.
destruct h.
why3 "Alt-Ergo,1.30," timelimit 2; admit.
replace x with ((x-1)+1)%Z by omega.
rewrite sum2; auto with zarith.
rewrite sum2; auto with zarith.
Admitted.

