(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import ZArith.
Require Import Rbase.
Require int.Int.
Require Jessie_memory_model.

(* Why3 assumption *)
Definition implb(x:bool) (y:bool): bool := match (x,
  y) with
  | (true, false) => false
  | (_, _) => true
  end.

Parameter usObject : Type.

Parameter interface : Type.

Parameter usException_tag: (Jessie_memory_model.tag_id usObject).

Parameter usObject_tag: (Jessie_memory_model.tag_id usObject).

Axiom usException_parenttag_Object : (Jessie_memory_model.parenttag usException_tag
  usObject_tag).

Parameter usFibonacci_tag: (Jessie_memory_model.tag_id usObject).

Axiom usFibonacci_parenttag_Object : (Jessie_memory_model.parenttag usFibonacci_tag
  usObject_tag).

(* Why3 assumption *)
Definition usNon_null_Object(x_0:(Jessie_memory_model.pointer usObject))
  (usObject_alloc_table:(Jessie_memory_model.alloc_table usObject)): Prop :=
  (0%Z <= (Jessie_memory_model.offset_max usObject_alloc_table x_0))%Z.

Axiom usObject_int : ((Jessie_memory_model.int_of_tag usObject_tag) = 1%Z).

Parameter usObject_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer usObject).

Axiom usObject_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  usObject)),
  (p = (usObject_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom usObject_parenttag_bottom : (Jessie_memory_model.parenttag usObject_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id usObject))).

Axiom usObject_tags : forall (x:(Jessie_memory_model.pointer usObject)),
  forall (usObject_tag_table:(Jessie_memory_model.tag_table usObject)),
  (Jessie_memory_model.instanceof usObject_tag_table x usObject_tag).

Parameter usString_tag: (Jessie_memory_model.tag_id usObject).

Axiom usString_parenttag_Object : (Jessie_memory_model.parenttag usString_tag
  usObject_tag).

Parameter usThrowable_tag: (Jessie_memory_model.tag_id usObject).

Axiom usThrowable_parenttag_Object : (Jessie_memory_model.parenttag usThrowable_tag
  usObject_tag).

Parameter interface_tag: (Jessie_memory_model.tag_id interface).

Axiom interface_int : ((Jessie_memory_model.int_of_tag interface_tag) = 1%Z).

Parameter interface_of_pointer_address: (Jessie_memory_model.pointer unit) ->
  (Jessie_memory_model.pointer interface).

Axiom interface_of_pointer_address_of_pointer_addr : forall (p:(Jessie_memory_model.pointer
  interface)),
  (p = (interface_of_pointer_address (Jessie_memory_model.pointer_address p))).

Axiom interface_parenttag_bottom : (Jessie_memory_model.parenttag interface_tag
  (Jessie_memory_model.bottom_tag :(Jessie_memory_model.tag_id interface))).

Axiom interface_tags : forall (x:(Jessie_memory_model.pointer interface)),
  forall (interface_tag_table:(Jessie_memory_model.tag_table interface)),
  (Jessie_memory_model.instanceof interface_tag_table x interface_tag).

(* Why3 assumption *)
Inductive isfib : Z -> Z -> Prop :=
  | isfib0 : (isfib 0%Z 0%Z)
  | isfib1 : (isfib 1%Z 1%Z)
  | isfibn : forall (n:Z), forall (r_0:Z), forall (p:Z), ((2%Z <= n)%Z /\
      ((isfib (n - 2%Z)%Z r_0) /\ (isfib (n - 1%Z)%Z p))) -> (isfib n
      (p + r_0)%Z).

(* Why3 assumption *)
Definition left_valid_struct_Object(p:(Jessie_memory_model.pointer usObject))
  (a:Z) (usObject_alloc_table:(Jessie_memory_model.alloc_table
  usObject)): Prop := ((Jessie_memory_model.offset_min usObject_alloc_table
  p) <= a)%Z.

(* Why3 assumption *)
Definition left_valid_struct_interface(p:(Jessie_memory_model.pointer
  interface)) (a:Z) (interface_alloc_table:(Jessie_memory_model.alloc_table
  interface)): Prop := ((Jessie_memory_model.offset_min interface_alloc_table
  p) <= a)%Z.

Axiom pointer_addr_of_Object_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (usObject_of_pointer_address p))).

Axiom pointer_addr_of_interface_of_pointer_address : forall (p:(Jessie_memory_model.pointer
  unit)),
  (p = (Jessie_memory_model.pointer_address (interface_of_pointer_address p))).

(* Why3 assumption *)
Definition right_valid_struct_Object(p:(Jessie_memory_model.pointer
  usObject)) (b:Z) (usObject_alloc_table:(Jessie_memory_model.alloc_table
  usObject)): Prop :=
  (b <= (Jessie_memory_model.offset_max usObject_alloc_table p))%Z.

(* Why3 assumption *)
Definition right_valid_struct_interface(p:(Jessie_memory_model.pointer
  interface)) (b:Z) (interface_alloc_table:(Jessie_memory_model.alloc_table
  interface)): Prop :=
  (b <= (Jessie_memory_model.offset_max interface_alloc_table p))%Z.

(* Why3 assumption *)
Definition strict_valid_root_Object(p:(Jessie_memory_model.pointer usObject))
  (a:Z) (b:Z) (usObject_alloc_table:(Jessie_memory_model.alloc_table
  usObject)): Prop := ((Jessie_memory_model.offset_min usObject_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max usObject_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_root_interface(p:(Jessie_memory_model.pointer
  interface)) (a:Z) (b:Z)
  (interface_alloc_table:(Jessie_memory_model.alloc_table
  interface)): Prop := ((Jessie_memory_model.offset_min interface_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max interface_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_Object(p:(Jessie_memory_model.pointer
  usObject)) (a:Z) (b:Z)
  (usObject_alloc_table:(Jessie_memory_model.alloc_table usObject)): Prop :=
  ((Jessie_memory_model.offset_min usObject_alloc_table p) = a) /\
  ((Jessie_memory_model.offset_max usObject_alloc_table p) = b).

(* Why3 assumption *)
Definition strict_valid_struct_interface(p:(Jessie_memory_model.pointer
  interface)) (a:Z) (b:Z)
  (interface_alloc_table:(Jessie_memory_model.alloc_table
  interface)): Prop := ((Jessie_memory_model.offset_min interface_alloc_table
  p) = a) /\ ((Jessie_memory_model.offset_max interface_alloc_table p) = b).

(* Why3 assumption *)
Definition valid_root_Object(p:(Jessie_memory_model.pointer usObject)) (a:Z)
  (b:Z) (usObject_alloc_table:(Jessie_memory_model.alloc_table
  usObject)): Prop := ((Jessie_memory_model.offset_min usObject_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max usObject_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_root_interface(p:(Jessie_memory_model.pointer interface))
  (a:Z) (b:Z) (interface_alloc_table:(Jessie_memory_model.alloc_table
  interface)): Prop := ((Jessie_memory_model.offset_min interface_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max interface_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_struct_Object(p:(Jessie_memory_model.pointer usObject))
  (a:Z) (b:Z) (usObject_alloc_table:(Jessie_memory_model.alloc_table
  usObject)): Prop := ((Jessie_memory_model.offset_min usObject_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max usObject_alloc_table
  p))%Z.

(* Why3 assumption *)
Definition valid_struct_interface(p:(Jessie_memory_model.pointer interface))
  (a:Z) (b:Z) (interface_alloc_table:(Jessie_memory_model.alloc_table
  interface)): Prop := ((Jessie_memory_model.offset_min interface_alloc_table
  p) <= a)%Z /\ (b <= (Jessie_memory_model.offset_max interface_alloc_table
  p))%Z.

Open Scope Z_scope.

(* Why3 goal *)
Theorem isfib_2_1 : (isfib 2%Z 1%Z).
(* YOU MAY EDIT THE PROOF BELOW *)
apply isfibn with (r_0:=0) (p:=1); intuition.
constructor.
constructor.
Qed.


